//Intel to Binary
////////////////////////////////////////////////////////////////////////////////
//
//bcc -mt -tDc -K elm@b2i.c
static  char __RIGHTS__[] = "(C) NILTechnique,1992." ;

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dir.h>

#define O_BINARY 0x8000
#define VERSION  "0.05"
#define TRUE       1 #define FALSE      0
#define USAGE    "Usage: elm@b2i <filename[.ROM]> [StartAddress(hex)]\n\n"
#define ERROPS   "Error opening source file "
#define ERROPT   "Error opening target file "
#define ALLDON   "All Done.\n\n"
#define WAIT     "Please wait...\n"
#define CRLF     "\n\r"
#define BCount   0x20

FILE *IFile, *OFile;


int main( int argc, char *argv[] )
{
    char Drive[MAXDRIVE], Dir[MAXDIR], File[MAXFILE], Ext[MAXEXT], *Path;
    register int i=0;

    int Byte_Count=BCount, Rec_Type=0, Address=0;
    char Buffer[BCount], Byte, Sum;

    printf( "\nBinary To Intel Converter (ELMARC Utilities) R" VERSION ",
%s\n",__RIGHTS__) ;
    printf( "Converts Binary Format to Intel Load Module Format.\n\n") ;
    if( argc < 2 ){
      printf( "%s", USAGE );
      return -1 ;
    }
    if( argc == 3)  sscanf( argv[2], "%x", &Address);
    strupr( argv[1] );
    Path = argv[1];
    fnsplit( Path, Drive, Dir, File, Ext);
    if( Ext != ".ROM") strcpy( Ext, ".ROM");
    fnmerge( Path, Drive, Dir, File, Ext);

    _fmode = O_BINARY;

    if((IFile = fopen( Path, "r" )) == NULL ){
      printf( "%s%s\n\n",ERROPS, Path);
      return -1;
    }

    strcpy( Ext, ".MDS");
    fnmerge( Path, Drive, Dir, File, Ext);

    if((OFile = fopen( Path, "w" )) == NULL ){
      printf( "%s%s\n\n",ERROPT, Path);
      return -1;
    }

    printf( "%s",WAIT);
    printf( ">>Converting %s.ROM to %s.MDS.\n", File, File);

    fwrite( CRLF, 2, 1, OFile);

    while((Byte_Count = fread( Buffer, 1, sizeof(Buffer),IFile)) != 0){

     fputc( ':', OFile );
     fprintf( OFile, "%02X%04X%02X", Byte_Count, Address, Rec_Type);
     Sum = Byte_Count + (Address>>8) + (Address&0xff) + Rec_Type;
     i = 0;
     while(i < Byte_Count){
    fprintf( OFile, "%02X", Buffer[i]);
    Sum += Buffer[i];
    i++;
     }

     Sum = (unsigned char)(~Sum+1);
     fprintf( OFile, "%02X", Sum );
     fwrite( CRLF, 2, 1, OFile);
     Address += Byte_Count;
    }

    fprintf( OFile, ":00%04X01FF\n\r", Address);
    fclose( IFile );
    fclose( OFile );
    printf("%s", ALLDON);
    return 0;
}
